<?php
/*
Purpose: Show a subset or all tasks

MyOrgbook V2.8

*/

include ('inc/session.inc');
include ('inc/template.inc');
include ('inc/functions.inc');

// checking for error / info messages
If (isset($_REQUEST['Info']))  {
	$Info = $_REQUEST['Info'];
} else {
	$Info = "";
}
If (isset($_REQUEST['Error'])) {
	$Error = $_REQUEST['Error'];
} else {
	$Error = "";
}

$ShowAction = '';
$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

if (!isset($_REQUEST['MyDate'])) {
 $MyDate = mktime();
} else{
 $MyDate = $_REQUEST['MyDate'];
}

// Show one task
if ((isset($_REQUEST['ReportType'])) && ($_REQUEST['ReportType'] == "Task")) {
	$query = "SELECT * FROM myorgbook_tasks WHERE taskid =" . $_REQUEST['taskid'];
	ShowReport($query);
}

// Show one day
if ((isset($_REQUEST['ReportType'])) && ($_REQUEST['ReportType'] == "Day")) {
	// requested date
	If (isset($_REQUEST['ReportDate'])) {
		$databasedate = date("Y-m-d", $_REQUEST['ReportDate']);
		// difference between $date1 and $date2 is day
		$date1 = strtotime("$databasedate 00:00");
		$date2 = strtotime("$databasedate 23:59");
		$query = "SELECT * FROM myorgbook_tasks WHERE uemail = '" . $_SESSION['Email'] . "' AND date BETWEEN '$date1' AND '$date2' ORDER BY 'date'";
		ShowReport($query);
	} else {
		// preparation for the calendar
		$ShowAction = "Day";
		$month_number = date("n",$MyDate);
		$year = date("Y",$MyDate);
	}
}

//Show one week
if ((isset($_REQUEST['ReportType'])) && ($_REQUEST['ReportType'] == "Week")) {
	If (isset($_REQUEST['ReportDate'])) {
		$databasedate = date("Y-m-d", $_REQUEST['ReportDate']);
		// difference between $date1 and $date2 is week
		$date1 = strtotime("$databasedate 00:00");
		$ReportDate = $_REQUEST['ReportDate'] + 518400;
		$databasedate = date("Y-m-d", $ReportDate);
		$date2 = strtotime("$databasedate 23:59");
		$query = "SELECT * FROM myorgbook_tasks WHERE uemail = '" . $_SESSION['Email'] . "' AND date BETWEEN '$date1' AND '$date2' ORDER BY 'date'";
		ShowReport($query);
	} else {
		// preparation for the calendar
		$ShowAction = "Week";
		$month_number = date("n",$MyDate);
		$year = date("Y",$MyDate);
	}
}

// Show all tasks between whatever dates the user picks
if ((isset($_REQUEST['ReportType'])) && ($_REQUEST['ReportType'] == "Custom")) {
	If ((isset($_REQUEST['ReportDate1'])) && (isset($_REQUEST['ReportDate2']))) {
		$date1 = mktime(0,0,0,date("n",$_REQUEST['ReportDate1']),date("j",$_REQUEST['ReportDate1']),date("Y",$_REQUEST['ReportDate1']));
		$date2 = mktime(23,59,59,date("n",$_REQUEST['ReportDate2']),date("j",$_REQUEST['ReportDate2']),date("Y",$_REQUEST['ReportDate2']));
		$query = "SELECT * FROM myorgbook_tasks WHERE uemail = '" . $_SESSION['Email'] . "' AND date BETWEEN '$date1' AND '$date2' ORDER BY 'date'";
		ShowReport($query);
	} else {
		// preparation for the calendar
		$ShowAction = "Custom";
		$month_number = date("n",$MyDate);
		$year = date("Y",$MyDate);
	}
}

Function ShowReport($query) {
	// getting some important variables
	global $db,$Theme;

	// executing the given query
	$result = $db->Execute($query);
	if ($result == false) die(msg('Query Failed'));
	$num = $result->RecordCount();
	//Defining templates
	$MyPage = New Template("Templates/$Theme/");
	$MyPage->set_file(array("MyFileHandle" => "Report.tpl",
			"MyTableElementHandle" => "Report_table_element.tpl"));
	// Setting the standard variables
	$MyPage->set_var("Task Report",msg('Task Report'));
	$MonthNames = msg('MonthNames');
	$MyPage->set_var("Date_Generated",msg('Generated on') . " " . $MonthNames[date("n")] . date(" j, Y, g:i a"));
	$MyPage->set_var("Task Title:",msg('Task Title:'));
	$MyPage->set_var("Date:",msg('Date:'));
	$MyPage->set_var("Priority:",msg('Priority:'));
	$MyPage->set_var("Task:",msg('Task:'));
	$MyPage->set_var("charset",msg('iso-8859-1'));
	// No results found
	if ($num == "0") {
		$MyPage->set_var("Report_content",msg('Nothing is scheduled for today.'));
		$MyPage->pparse("output","MyFileHandle");
		exit;
	} else {
		// Results found
		while (!$result->EOF) {
			$r = $result->fields;
			$MyPage->set_var("Day_Date",$MonthNames[date("n",$r["date"])] . date(" j, Y",$r["date"]) . "<HR>");
			$date = $MonthNames[date("n",$r["date"])] . date(" j, Y, g:i a",$r["date"]);
			$ttitle = $r["ttitle"];
			$print = $r["print"];
			$task = $r["task"];
			if ($r["taskdone"] == 1) {
				$time = "<s>$time</s>";
				$ttitle = "<s>$ttitle</s>";
				$print = "<s>$print</s>";
				$task = "<s>$task</s>";
				$date = "<s>$date</s>";
			}
			$MyPage->set_var("ttitle_text",$ttitle);
			$MyPage->set_var("date_text",$date);
			$MyPage->set_var("print_text",$print);
			$MyPage->set_var("task_text",$task);
			$MyPage->parse("Report_content","MyTableElementHandle",true);
			$result->MoveNext();
		}
	// outputting result		
	$MyPage->pparse("output","MyFileHandle");
	exit;
	}
}


include ('inc/calendar.inc');

if ((isset($_REQUEST['ReportType'])) && ($_REQUEST['ReportType'] == "All")) {
	$query = "SELECT * FROM myorgbook_tasks WHERE uemail = '" . $_SESSION['Email'] . "' ORDER BY date";
	$result = $db->Execute($query);
	if ($result == false) die($lang_Query_failed);
	if ($result->RecordCount() == 0) {
		header("Location: ".$BASE_URL_SCHEME."://".$_SERVER['SERVER_NAME']."/".substr($_SERVER['PHP_SELF'], 1, strrpos($_SERVER['PHP_SELF'],"/")) . "ShowTasks.php?Info=" . msg('No Task Found'));
		exit;
	}

	//Defining templates
	$MyPage = New Template("Templates/$Theme/");
	$MyPage->set_file(array("MyHeaderHandle" => "header.tpl",
			"MyFileHandle" => "Report_all.tpl",
			"MyTableElementHandle" => "Report_all_table_element.tpl"));
	// Setting the standard variables
	include ('inc/Templateheader.inc');
	// parsing header
	$MyPage->parse("header","MyHeaderHandle",true);
	// Setting up static content variables
	$MyPage->set_var("Date:",msg('Date:'));
	$MyPage->set_var("Time:",msg('Time:'));
	$MyPage->set_var("Task Title:",msg('Task Title:'));
	$MonthNames = msg('MonthNames');
	$MyPage->set_var("Date_Generated",msg('Generated on') . " " . $MonthNames[date("n")] . date(" j, Y, g:i a"));
	$MyPage->set_var("Back",msg('Back'));
	$MyPage->set_var("Report",msg('Report'));
	$MyPage->set_var("Calendar",msg('Calendar'));
	$MyPage->set_var("Add Task",msg('Add Task'));

	while (!$result->EOF) {
		$r = $result->fields;
		$date = $MonthNames[date("n",$r["date"])] . date(" j, Y",$r["date"]);
		$time = date("g:i a",$r["date"]);
		$ttitle = $r["ttitle"];
		$print = $r["print"];
		$taskid  = $r["taskid"];
		$MyPage->set_var("date",$date);
		$MyPage->set_var("time",$time);
		$MyPage->set_var("ttitle",$ttitle);
		$MyPage->set_var("Delete",msg('Delete'));
		$MyPage->set_var("The task is successfully deleted",msg('The task is successfully deleted'));
		$MyPage->set_var("Details",msg('Details'));
		$MyPage->set_var("Task report wizard",msg('Task report wizard'));
		$MyPage->set_var("DoWhat",msg('All'));
		$MyPage->set_var("Timestamp",$MyDate);
		$MyPage->set_var("te_taskid",$taskid);
		$MyPage->parse("Report_content","MyTableElementHandle",true);
		$result->MoveNext();
	}
	$MyPage->pparse("output","MyFileHandle");
	exit;
}

//Defining templates
$MyPage = New Template("Templates/$Theme/");
$MyPage->set_file(array("MyHeaderHandle" => "header.tpl",
		"MyFileHandle" => "Report_select.tpl",
		"MyError" => "error.tpl",
		"MyInfo" => "info.tpl"));
// Checking for error
if ($Error != "") {
	$MyPage->set_var("error_text",$Error);
	$MyPage->parse("Error_Element","MyError");
}
// Checking for info
if ($Info != "") {
	$MyPage->set_var("info_text",$Info);
	$MyPage->parse("Info_Element","MyInfo");
}
// Setting the standard variables
include ('inc/Templateheader.inc');
// parsing header
$MyPage->parse("header","MyHeaderHandle",true);
// Setting up static content variables
$MyPage->set_var("Back",msg('Back'));
$MyPage->set_var("Report",msg('Report'));
$MyPage->set_var("Calendar",msg('Calendar'));
$MyPage->set_var("Add Task",msg('Add Task'));
$MyPage->set_var("Task report wizard",msg('Task report wizard'));
$MyPage->set_var("Please choose a period",msg('Please choose a period'));
$MyPage->set_var("Day",msg('Day'));
$MyPage->set_var("Week",msg('Week'));
$MyPage->set_var("All",msg('All'));
$MyPage->set_var("Custom",msg('Custom'));
$MyPage->set_var("DoWhat",msg('Select'));
$MyPage->set_var("Timestamp",$MyDate);

if ($ShowAction == "Day") {
	$cal = new ShowDayCalendar;
	$cal->setStartDay(1);
	$cal->dayNames = msg('DayCharNames');
	$cal->monthNames = msg('MonthNames');
	// Setting up calendar
	$MyPage->set_var("calendar",$cal->getMonthView($month_number, $year));
	$MyPage->set_var("DoWhat",msg('Day'));
}

if ($ShowAction == "Week") {
	$cal = new ShowWeekCalendar;
	$cal->setStartDay(1);
	$cal->dayNames = msg('DayCharNames');
	$cal->monthNames = msg('MonthNames');
	// Setting up calendar
	$MyPage->set_var("calendar",$cal->getMonthView($month_number, $year));
	$MyPage->set_var("DoWhat",msg('Week'));
}

if ($ShowAction == "Custom") {
	if (!isset($_REQUEST['ReportDate1'])) {
		$DateChoice = msg('First');
	} else {
		$DateChoice = msg('Second');
	}
	$tmp_text = msg('Please choose a period') . " ($DateChoice).<br><br>\n";
	$cal = new ShowCustomCalendar;
	$cal->setStartDay(1);
	$cal->dayNames = msg('DayCharNames');
	$cal->monthNames = msg('MonthNames');
	// Setting up calendar
	$MyPage->set_var("calendar",$tmp_text . $cal->getMonthView($month_number, $year));
	$MyPage->set_var("DoWhat",msg('Custom'));
}
//outputting page
$MyPage->pparse("output","MyFileHandle");
?>
