<?php
/*
Purpose: Show the gathered data in the form of statistics

MyOrgbook V2.8


*/

include ('inc/conf.inc.php');
include ('inc/functions.inc');

// Check if Admin
if ((isset($_SESSION["IsAdmin"])) && (!$_SESSION["IsAdmin"])) {
		include('index.php');
		exit;
}

if (isset($_REQUEST['month'])) $month = $_REQUEST['month'];
if (isset($_REQUEST['year'])) $year = $_REQUEST['year'];

// Some Date functions
function daysInMonth($month="",$year="")
    {
        if(empty($year)) {
            $year = date("Y");
        }
        if(empty($month)) {
            $month = date("n");
        }

        if($month == 2) {
            if(isLeapYear($year)) {
                return 29;
             } else {
                return 28;
            }
        } elseif($month == 4 or $month == 6 or $month == 9 or $month == 11) {
            return 30;
        } else {
            return 31;
        }
    }

function isLeapYear($year="")
    {
        if(empty($year)) {
            $year = date("Y");
        }

        if(strlen($year) != 4) {
            return false;
        }

        if(preg_match("/\D/",$year)) {
            return false;
        }

        return (($year % 4 == 0 && $year % 100 != 0) || $year % 400 == 0);
}


// Something needs deleting?

If (isset($_REQUEST['delete'])) {
	// Getting month range
	$year = date("Y",$_REQUEST['delete']);
	$month = date("n",$_REQUEST['delete']);
	$days = daysInMonth($month,$year);
	$BeginOfMonth = mktime (0,0,0,$month,1,$year);
	$EndOfMonth = mktime (23,59,59,$month,$days,$year);

	// Executing queries
	$result = $db->Execute("DELETE FROM `myorgbook_stat_login` WHERE timestamp BETWEEN $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$result = $db->Execute("DELETE FROM `myorgbook_stat_tasks` WHERE timestamp BETWEEN $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$result = $db->Execute("DELETE FROM `myorgbook_stat_contacts` WHERE timestamp BETWEEN $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$result = $db->Execute("DELETE FROM `myorgbook_stat_newusers` WHERE timestamp BETWEEN $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$result = $db->Execute("DELETE FROM `myorgbook_stat_reminder` WHERE timestamp BETWEEN $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
}

// Outputting a header
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Myorgbook Statistics</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>

<body>

<?php

// User statistics
if (isset($_REQUEST['email'])) {
	$days = daysInMonth($month,$year);
	$BeginOfMonth = mktime (0,0,0,$month,1,$year);
	$EndOfMonth = mktime (23,59,59,$month,$days,$year);

	$USER = $_REQUEST['email'];
	echo "<center><H1>Details for $USER</H1></center>";
	echo "<center><a href=\"statistics.php\">Back</a></center><br><br>";

	if ($USER == '') exit;
	// Getting Data
	// Getting succeeded logins
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_login` where `username` = '$USER' AND `timestamp` between $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$SucceedLoginMonth = $result->fields[0];
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_login` where `username` = '$USER'");
	if ($result == false) die(msg('Query Failed'));
	$SucceedLoginTotal = $result->fields[0];
	// getting added tasks
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_tasks` where `username` = '$USER' AND `timestamp` between $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$TasksMonth = $result->fields[0];
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_tasks` where `username` = '$USER'");
	if ($result == false) die(msg('Query Failed'));
	$TasksTotal = $result->fields[0];
	// getting added contacts
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_contacts` where `username` = '$USER' AND `timestamp` between $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$ContactsMonth = $result->fields[0];
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_contacts` where `username` = '$USER'");
	if ($result == false) die(msg('Query Failed'));
	$ContactsTotal = $result->fields[0];
	// getting sent reminders
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_reminder` where `username` = '$USER' AND `timestamp` between $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$RemindMonth = $result->fields[0];
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_reminder` where `username` = '$USER'");
	if ($result == false) die(msg('Query Failed'));
	$RemindTotal = $result->fields[0];

	//throwing output
	//month
	echo "<center><table>";
	echo "<tr><td><H3>Details for " . date("F Y",mktime(0,0,0,$month,1,$year)) . "</H3></td></tr>";
	echo "<tr><td><b>Succeeded logins:</b></td><td>$SucceedLoginMonth</td></tr>";
	echo "<tr><td><b>Added tasks:</b></td><td>$TasksMonth</td></tr>";
	echo "<tr><td><b>Added contacts:</b></td><td>$ContactsMonth</td></tr>";
	echo "<tr><td><b>Sent reminders:</b></td><td>$RemindMonth</td></tr>";

	// Seperating month and total
	echo "<tr><td>&nbsp</td></tr>";
	echo "<tr><td>&nbsp</td></tr>";

	// Total output
	echo "<tr><td><H3>Totals</H3></td></tr>";
	echo "<tr><td><b>Succeeded logins:</b></td><td>$SucceedLoginTotal</td></tr>";
	echo "<tr><td><b>Added tasks:</b></td><td>$TasksTotal</td></tr>";
	echo "<tr><td><b>Added contacts:</b></td><td>$ContactsTotal</td></tr>";
	echo "<tr><td><b>Sent reminders:</b></td><td>$RemindTotal</td></tr>";

	echo "</table></center></body></html>";
	exit;
}

// IP statistics?
if (isset($_REQUEST['ip'])) {
	$days = daysInMonth($month,$year);
	$BeginOfMonth = mktime (0,0,0,$month,1,$year);
	$EndOfMonth = mktime (23,59,59,$month,$days,$year);

	$IP = $_REQUEST['ip'];
	echo "<center><H1>Details for $IP</H1></center>";
	echo "<center><a href=\"statistics.php\">Back</a></center><br><br>";

	if ($IP != "") {
		// Samspade link
		echo "<center><a href=\"http://www.samspade.org/t/lookat?a=$IP\" target=\"_blank\">Do Stuff</a><br><br>";
		// getting failed logins
		$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_login` where (`username` = 'FAILED') AND (`userip` = '$IP') AND (`timestamp` between $BeginOfMonth AND $EndOfMonth)");
		if ($result == false) die(msg('Query Failed'));
		$FailedLoginMonth = $result->fields[0];
		$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_login` where (`username` = 'FAILED') AND (`userip` = '$IP')");
		if ($result == false) die(msg('Query Failed'));
		$FailedLoginTotal = $result->fields[0];
		// Getting users
		$UserMonth = $db->Execute("SELECT distinct `username` FROM `myorgbook_stat_login` where (`userip` = '$IP') AND (`timestamp` between $BeginOfMonth AND $EndOfMonth)");
		if ($UserMonth == false) die(msg('Query Failed'));
		$UserTotal = $db->Execute("SELECT distinct `username` FROM `myorgbook_stat_login` where (`userip` = '$IP')");
		if ($UserTotal == false) die(msg('Query Failed'));
		// Getting browsers
		$BrowserMonth = $db->Execute("SELECT distinct `useragent` FROM `myorgbook_stat_login` where (`userip` = '$IP') AND (`timestamp` between $BeginOfMonth AND $EndOfMonth)");
		if ($BrowserMonth == false) die(msg('Query Failed'));
		$BrowserTotal = $db->Execute("SELECT distinct `useragent` FROM `myorgbook_stat_login` where (`userip` = '$IP')");
		if ($BrowserTotal == false) die(msg('Query Failed'));

		// Throwing some output
		// month output
		echo "<table>";
		echo "<tr><td><H3>Details for " . date("F Y",mktime(0,0,0,$month,1,$year)) . "</H3></td></tr>";
		echo "<tr><td><b>Failed logins:</b></td><td>$FailedLoginMonth</td></tr>";
		echo "<tr><td>&nbsp</td></tr>";
		echo "<tr><td colspan=\"2\"><b>Users with $IP</b></td></tr>";
		while (!$UserMonth->EOF) {
			echo "<tr><td colspan=\"2\">" . $UserMonth->fields[0] . "</td></tr>";
			$UserMonth->MoveNext();
		}
		echo "<tr><td>&nbsp</td></tr>";
		echo "<tr><td colspan=\"2\"><b>Useragent</b></td></tr>";
		while (!$BrowserMonth->EOF) {
			echo "<tr><td colspan=\"2\">" . $BrowserMonth->fields[0] . "</td></tr>";
			$BrowserMonth->MoveNext();
		}
		// Seperating month and total
		echo "<tr><td>&nbsp</td></tr>";
		echo "<tr><td>&nbsp</td></tr>";

		// Total output
		echo "<tr><td><H3>Totals</H3></td></tr>";
		echo "<tr><td><b>Failed logins:</b></td><td>$FailedLoginTotal</td></tr>";
		echo "<tr><td>&nbsp</td></tr>";
		echo "<tr><td colspan=\"2\"><b>Users with $IP</b></td></tr>";
		while (!$UserTotal->EOF) {
			echo "<tr><td colspan=\"2\">" . $UserTotal->fields[0] . "</td></tr>";
			$UserTotal->MoveNext();
		}
		echo "<tr><td>&nbsp</td></tr>";
		echo "<tr><td colspan=\"2\"><b>Useragent</b></td></tr>";
		while (!$BrowserTotal->EOF) {
			echo "<tr><td colspan=\"2\">" . $BrowserTotal->fields[0] . "</td></tr>";
			$BrowserTotal->MoveNext();
		}
		echo "</table></center></body></html>";
	}
	// No need for more output, let's exit
	exit;
}
// Detailed or global statistics?

If (isset($_REQUEST['month'])) {
	// Details of a month requested
	echo "<center><H1>Details for " . date("F Y",mktime(0,0,0,$month,1,$year)) . "</H1></center>";
	echo "<center><a href=\"statistics.php\">Back</a></center><br><br>";
	// Setting the month range
	$days = daysInMonth($month,$year);
	$BeginOfMonth = mktime (0,0,0,$month,1,$year);
	$EndOfMonth = mktime (23,59,59,$month,$days,$year);

	// Getting Data
	// Getting succeeded logins
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_login` where `username` <> 'FAILED' AND `timestamp` between $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$SucceedLogin = $result->fields[0];
	// getting failed logins
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_login` where `username` = 'FAILED' AND `timestamp` between $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$FailedLogin = $result->fields[0];
	// getting added tasks
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_tasks` where `timestamp` between $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$Tasks = $result->fields[0];
	// getting added contacts
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_contacts` where `timestamp` between $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$Contacts = $result->fields[0];
	// getting sent reminders
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_reminder` where `timestamp` between $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$Remind = $result->fields[0];
	// getting new users
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_newusers` where `timestamp` between $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$NewUsers = $result->fields[0];
	// Getting top 10 users
	$TopTenLogin = $db->Execute("SELECT `username`, COUNT(*) AS Total FROM `myorgbook_stat_login` where `timestamp` between $BeginOfMonth AND $EndOfMonth GROUP BY `username` ORDER BY `Total` DESC, `username`");
	if ($TopTenLogin == false) die(msg('Query Failed'));
	// Getting top 10 failed logins
	$TopTenFailed = $db->Execute("SELECT `userip`, COUNT(*) AS Total FROM `myorgbook_stat_login` where `username`=\"FAILED\" AND `timestamp` between $BeginOfMonth AND $EndOfMonth GROUP BY `userip` ORDER BY `Total` DESC, `userip`");
	if ($TopTenFailed == false) die(msg('Query Failed'));
	// Getting browser top 10
	$TopTenBrowser = $db->Execute("SELECT `useragent`, COUNT(*) AS Total FROM `myorgbook_stat_login` where `timestamp` between $BeginOfMonth AND $EndOfMonth GROUP BY `useragent` ORDER BY `Total` DESC, `useragent`");
	if ($TopTenBrowser == false) die(msg('Query Failed'));
	// Getting new user names
	$NewUserNames = $db->Execute("SELECT `username` FROM `myorgbook_stat_newusers` where `timestamp` between $BeginOfMonth AND $EndOfMonth");
	if ($NewUserNames == false) die(msg('Query Failed'));

	// Outputting Data
	echo "<center><table>";
	// General statiscal data
	echo "<tr><td colspan=\"2\" align=\"center\"><H3>General information</H3></td></tr>";
	echo "<tr><td>&nbsp</td></tr>";
	echo "<tr><td><b>Total Succeeded logins:</b></td><td>$SucceedLogin</td></tr>";
	echo "<tr><td><b>Total Failed logins:</b></td><td>$FailedLogin</td></tr>";
	echo "<tr><td><b>Total added tasks:</b></td><td>$Tasks</td></tr>";
	echo "<tr><td><b>Total added contacts:</b></td><td>$Contacts</td></tr>";
	echo "<tr><td><b>Total sent reminders:</b></td><td>$Remind</td></tr>";
	echo "<tr><td><b>Total new users:</b></td><td>$NewUsers</td></tr>";
	echo "</table><br>\n";
	// Top 10 users to login
	echo "<table>";
	echo "<tr><td>&nbsp</td></tr>";
	echo "<tr><td colspan=\"2\" align=\"center\"><H3>Top 10 users to login</H3></td></tr>";
	echo "<tr><td>&nbsp</td></tr>";
	for ($i=1;$i<=10;$i++){
		if ($TopTenLogin->fields[0] == "FAILED") {
			$i--;
		} else {
			echo "<tr><td><a href=\"statistics.php?email=" . $TopTenLogin->fields[0] . "&month=$month&year=$year\">" . $TopTenLogin->fields[0] . "</a></td><td>" . $TopTenLogin->fields[1] . "</td></tr>";
		}
		$TopTenLogin->MoveNext();
	}
	echo "</table><br>\n";
	// Top 10 ip's to fail
	echo "<table>";
	echo "<tr><td>&nbsp</td></tr>";
	echo "<tr><td colspan=\"2\" align=\"center\"><H3>Top 10 ip's to fail login</H3></td></tr>";
	echo "<tr><td>&nbsp</td></tr>";
	for ($i=1;$i<=10;$i++){
		echo "<tr><td><a href=\"statistics.php?ip=" . $TopTenFailed->fields[0] . "&month=$month&year=$year\">" . $TopTenFailed->fields[0] . "</a></td><td>" . $TopTenFailed->fields[1] . "</td></tr>";
		$TopTenFailed->MoveNext();
	}
	echo "</table><br>\n";
	// Top 10 browsers
	echo "<table>";
	echo "<tr><td>&nbsp</td></tr>";
	echo "<tr><td colspan=\"2\" align=\"center\"><H3>Top 10 useragents (browser/os)</H3></td></tr>";
	echo "<tr><td>&nbsp</td></tr>";
	for ($i=1;$i<=10;$i++){
		echo "<tr><td>" . $TopTenBrowser->fields[0] . "</td><td>" . $TopTenBrowser->fields[1] . "</td></tr>";
		$TopTenBrowser->MoveNext();
	}
	echo "</table><br>\n";
	// All new users
	echo "<table>";
	echo "<tr><td>&nbsp</td></tr>";
	echo "<tr><td colspan=\"2\" align=\"center\"><H3>New Users</H3></td></tr>";
	echo "<tr><td>&nbsp</td></tr>";
	while (!$NewUserNames->EOF) {
		echo "<tr><td colspan=\"2\"><a href=\"statistics.php?email=" . $NewUserNames->fields[0] . "&month=$month&year=$year\">" . $NewUserNames->fields[0] . "</a></td></tr>";
		$NewUserNames->MoveNext();
	}

	echo "</table></center></body></html>";
	// no need for the rest of code, so let's bail out
	exit;
}


// Beginning with detailed statistics
?>
<TABLE WIDTH=800 BORDER=2 CELLSPACING=1 CELLPADDING=1>
<TR><TH COLSPAN=14 BGCOLOR="#C0C0C0" ALIGN=center>Summary by Month</TH></TR>
<TR><TH ALIGN=left ROWSPAN=2 BGCOLOR="#C0C0C0"><FONT SIZE="-1">Month</FONT></TH>
<TH ALIGN=center COLSPAN=6 BGCOLOR="#C0C0C0"><FONT SIZE="-1">Daily Avg</FONT></TH>
<TH ALIGN=center COLSPAN=6 BGCOLOR="#C0C0C0"><FONT SIZE="-1">Monthly Totals</FONT></TH>
<TH ALIGN=center COLSPAN=6 BGCOLOR="#C0C0C0"><FONT SIZE="-1"> </FONT></TH></TR>
<TR><TH ALIGN=center BGCOLOR="#C0C0C0"><FONT SIZE="-1">GoodLogins</FONT></TH>
<TH ALIGN=center BGCOLOR="#C0C0C0"><FONT SIZE="-1">FailedLogins</FONT></TH>
<TH ALIGN=center BGCOLOR="#C0C0C0"><FONT SIZE="-1">AddedTasks</FONT></TH>
<TH ALIGN=center BGCOLOR="#C0C0C0"><FONT SIZE="-1">AddedContacts</FONT></TH>
<TH ALIGN=center BGCOLOR="#C0C0C0"><FONT SIZE="-1">Reminders</FONT></TH>
<TH ALIGN=center BGCOLOR="#C0C0C0"><FONT SIZE="-1">NewUsers</FONT></TH>
<TH ALIGN=center BGCOLOR="#C0C0C0"><FONT SIZE="-1">GoodLogins</FONT></TH>
<TH ALIGN=center BGCOLOR="#C0C0C0"><FONT SIZE="-1">FailedLogins</FONT></TH>
<TH ALIGN=center BGCOLOR="#C0C0C0"><FONT SIZE="-1">AddedTasks</FONT></TH>
<TH ALIGN=center BGCOLOR="#C0C0C0"><FONT SIZE="-1">AddedContacts</FONT></TH>
<TH ALIGN=center BGCOLOR="#C0C0C0"><FONT SIZE="-1">Reminders</FONT></TH>
<TH ALIGN=center BGCOLOR="#C0C0C0"><FONT SIZE="-1">NewUsers</FONT></TH>
<TH ALIGN=center BGCOLOR="#C0C0C0"><FONT SIZE="-1"> </FONT></TH></TR>
<?php

// Getting the date range of which should be reported.
// First date is the only important, the admin has to be logged in
// to view the page so the last date is today :-)

$result = $db->Execute("SELECT min(timestamp) FROM `myorgbook_stat_login`");
if ($result == false) die(msg('Query Failed'));
if ($result->fields[0] != NULL) $FirstMonth = $result->fields[0];
$result->close();
$result = $db->Execute("SELECT min(timestamp) FROM `myorgbook_stat_tasks`");
if ($result == false) die(msg('Query Failed'));
If (($FirstMonth > $result->fields[0]) && ($result->fields[0] != NULL)) $FirstMonth = $result->fields[0];
$result->close();
$result = $db->Execute("SELECT min(timestamp) FROM `myorgbook_stat_contacts`");
if ($result == false) die(msg('Query Failed'));
If (($FirstMonth > $result->fields[0]) && ($result->fields[0] != NULL)) $FirstMonth = $result->fields[0];
$result->close();
$result = $db->Execute("SELECT min(timestamp) FROM `myorgbook_stat_newusers`");
if ($result == false) die(msg('Query Failed'));
If (($FirstMonth > $result->fields[0]) && ($result->fields[0] != NULL)) $FirstMonth = $result->fields[0];
$result->close();
$result = $db->Execute("SELECT min(timestamp) FROM `myorgbook_stat_reminder`");
if ($result == false) die(msg('Query Failed'));
If (($FirstMonth > $result->fields[0]) && ($result->fields[0] != NULL)) $FirstMonth = $result->fields[0];
$result->close();

// Set loop runner
$LoopEndend = False;
// Set date var's
$year = date("Y");
$month = date("n");

// Do loop
While(!$LoopEndend) {
	// Showing month
	echo "<TR><TD NOWRAP><FONT SIZE='-1'><A HREF=statistics.php?month=$month&year=$year>" . date("M Y",mktime(0,0,0,$month,1,$year)) . "</A></FONT></TD>\n";
	$days = daysInMonth($month,$year);

	// Getting the month range
	$BeginOfMonth = mktime (0,0,0,$month,1,$year);
	$EndOfMonth = mktime (23,59,59,$month,$days,$year);

	// Getting succeeded logins
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_login` where `username` <> 'FAILED' AND `timestamp` between $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$SucceedLogin = $result->fields[0];
	$AvgSucceedLogin = round($SucceedLogin / date("j"),2);

	// getting failed logins
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_login` where `username` = 'FAILED' AND `timestamp` between $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$FailedLogin = $result->fields[0];
	$AvgFailedLogin = round($FailedLogin / date("j"),2);

	// getting added tasks
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_tasks` where `timestamp` between $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$Tasks = $result->fields[0];
	$AvgTasks = round($Tasks / date("j"),2);

	// getting added contacts
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_contacts` where `timestamp` between $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$Contacts = $result->fields[0];
	$AvgContacts = round($Contacts / date("j"),2);

	// getting sent reminders
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_reminder` where `timestamp` between $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$Remind = $result->fields[0];
	$AvgRemind = round($Remind / date("j"),2);

	// getting new users
	$result = $db->Execute("SELECT count(*) FROM `myorgbook_stat_newusers` where `timestamp` between $BeginOfMonth AND $EndOfMonth");
	if ($result == false) die(msg('Query Failed'));
	$NewUsers = $result->fields[0];
	$AvgNewUsers = round($NewUsers / date("j"),2);

	// Parsing output
	// Daily Averages
	echo "<TD ALIGN=right><FONT SIZE='-1'>$AvgSucceedLogin</FONT></TD>\n";
	echo "<TD ALIGN=right><FONT SIZE='-1'>$AvgFailedLogin</FONT></TD>\n";
	echo "<TD ALIGN=right><FONT SIZE='-1'>$AvgTasks</FONT></TD>\n";
	echo "<TD ALIGN=right><FONT SIZE='-1'>$AvgContacts</FONT></TD>\n";
	echo "<TD ALIGN=right><FONT SIZE='-1'>$AvgRemind</FONT></TD>\n";
	echo "<TD ALIGN=right><FONT SIZE='-1'>$AvgNewUsers</FONT></TD>\n";
	// Monthly totals
	echo "<TD ALIGN=right><FONT SIZE='-1'>$SucceedLogin</FONT></TD>\n";
	echo "<TD ALIGN=right><FONT SIZE='-1'>$FailedLogin</FONT></TD>\n";
	echo "<TD ALIGN=right><FONT SIZE='-1'>$Tasks</FONT></TD>\n";
	echo "<TD ALIGN=right><FONT SIZE='-1'>$Contacts</FONT></TD>\n";
	echo "<TD ALIGN=right><FONT SIZE='-1'>$Remind</FONT></TD>\n";
	echo "<TD ALIGN=right><FONT SIZE='-1'>$NewUsers</FONT></TD>\n";
	echo "<TD ALIGN=right><FONT SIZE='-1'><A HREF=statistics.php?delete=" . mktime(0,0,0,$month,1,$year) . ">Delete</A></FONT></TD>\n";

	// Going to next month
	$NextMonth = mktime(0,0,0,$month - 1,1, $year);
	$month = date("n",$NextMonth);
	$year = date("Y",$NextMonth);

	// Check if the loop should be ended
	if ((date("Y",$FirstMonth) == $year) AND (date("n",$FirstMonth) - 1 == $month)) $LoopEndend = True;
}
echo "</table></center></body></html>";

?>
